<template>
  <BaseModal @close="close" title="My Contacts">
    <template v-slot:content>
      <div class="content">
        <form class="position-sticky bg-white px-3 py-1">
          <div class="input-group border-bottom">
            <div class="input-group-prepend">
              <span id="basic-addon1" class="input-group-text border-0">
                <i class="icon-search f-16"></i>
              </span>
            </div>
            <input
              id="transferAmount"
              type="text"
              placeholder="Search Contacts"
              aria-label
              aria-describedby="basic-addon2"
              class="form-control border-0"
              v-model="searchText"
            />
          </div>
        </form>
        <ul class="list-group list-group-flush" v-if="noResultFound">
          <li class="list-group-item border-0 d-flex align-items-center bg-white"
          >No match found</li>
        </ul>
        <div v-if="!noResultFound">
          <ClickableHighlightRow 
            v-for="contact in contactList"
            :key="contact.address"
            showButton
            :text="contactNameDisplay(contact)"
            :selected="selectedContact === contact.address"
            @click-item="toggleContactSelection(contact.address)"
            @click-right-button="detailContact(contact)"
          />
        </div>
      </div>
    </template>
    <template v-slot:footer>
      <div class="contact-detail-footer">
        <div>
          <button
            type="button"
            class="add-contact btn btn-contacts btn-contacts-add f-18 footer-btn"
            @click.prevent="addContact"
          >
            Add Contact
          </button>
        </div>
        <div>
          <button
            @click.prevent="transferAmountTo(selectedContact)"
            role="button"
            class="btn btn-send btn-send-main f-18 footer-btn"
            :disabled="!selectedContact"
          >
            Send Payment
          </button>
        </div>
      </div>
    </template>
  </BaseModal>
</template>

<script lang="ts">
import { Component } from "vue-property-decorator";
import { mixins } from "vue-class-component";

import displayMessages from "@/constants/displayMessages";
import ContactsModalUtils from "@/mixins/ContactsModalUtils";
import Contact from "@/models/Contact";
import ContactAddModal from "@/components/buildings/ContactAddModal.vue";
import ContactDetailModal from "@/components/buildings/ContactDetailModal.vue";
import displayContactName from "@/lib/displayContactName";
import ClickableHighlightRow from "@/components/bricks/ClickableHighlightRow.vue";

@Component({
  components: {
    ClickableHighlightRow
  }
})
export default class ContactsListModal extends mixins(ContactsModalUtils) {
  public searchText = displayMessages.EMPTY_MSG;
  public selectedContact = "";

  get contactList(): Contact[] {
    const contacts = this.contactsModule.contacts;
    const contactsList: Contact[] = [];
    const regexp = this.searchText
      ? new RegExp(this.searchText.toLowerCase(), "g")
      : undefined;
    Object.keys(contacts).forEach((address: string) => {
      if ((regexp && address.toLowerCase().match(regexp) !== null) || !regexp) {
        contactsList.push({ ...contacts[address], address });
      }
    });
    return contactsList;
  }

  get noResultFound(): boolean {
    return this.contactList.length === 0 && this.searchText.length > 0;
  }

  get contactNameDisplay() {
    return (contact: Contact) => displayContactName(contact);
  }

  public addContact() {
    this.modalModule.openOrReplaceModal({ modal: ContactAddModal, attr: {} });
  }

  public detailContact(contact: Contact) {
    this.modalModule.openOrReplaceModal({
      modal: ContactDetailModal,
      attr: { contact }
    });
  }

  public toggleContactSelection(address: string) {
    if (this.selectedContact === address) {
      this.selectedContact = "";
      return;
    }
    this.selectedContact = address;
  }
}
</script>

<style lang="scss" scoped>
.content {
  min-height: 30vh;
  width: 100%;
}

.contact-detail-footer {
  display: flex;
  align-items: center;
  justify-content: space-between;

  .add-contact {
    padding: 12px 14px 12px 14px;
  }
}

.footer-btn {
  margin: 0;
}
</style>
